## pax-utils 0.1.13.dfsg.1

=== Makefile ===
# Copyright 2003 Ned Ludd <solar@linbsd.net>
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.55 2006/05/14 05:52:46 vapier Exp $
####################################################################

check_gcc=$(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
	then echo "$(1)"; else echo "$(2)"; fi)

####################################################################
WFLAGS    := -Wall -Wunused -Wimplicit -Wshadow -Wformat=2 \
             -Wmissing-declarations -Wmissing-prototypes -Wwrite-strings \
             -Wbad-function-cast -Wnested-externs -Wcomment -Winline \
             -Wchar-subscripts -Wcast-align -Wno-format-nonliteral \
             $(call check_gcc, -Wdeclaration-after-statement) \
             $(call check-gcc, -Wsequence-point) \
             $(call check-gcc, -Wextra)

CFLAGS    ?= -O2 -pipe
CPPFLAGS  += -D_GNU_SOURCE
LDFLAGS   +=
LIBS      :=
DESTDIR    =
PREFIX    := $(DESTDIR)/usr
STRIP     := strip
MKDIR     := mkdir -p
CP        := cp

# Some fun settings
#CFLAGS   += -DEBUG -g
#LDFLAGS  += -pie

ifeq ($(USE_CAP),yes)
CPPFLAGS-pspax.c += -DWANT_SYSCAP
LIBS-pspax       += -lcap
endif

ifdef PV
CPPFLAGS  += -DVERSION=\"$(PV)\"
endif

####################################################################
ELF_TARGETS  = scanelf pspax dumpelf
ELF_OBJS     = $(ELF_TARGETS:%=%.o) paxelf.o
MACH_TARGETS = scanmacho
MACH_OBJS    = $(MACH_TARGETS:%=%.o) paxmacho.o
OBJS         = $(ELF_OBJS) $(MACH_OBJS) paxinc.o
TARGETS      = $(ELF_TARGETS) $(MACH_TARGETS)
MPAGES       = $(TARGETS:%=man/%.1)
SOURCES      = $(OBJS:%.o=%.c)

ifneq ($(MACH),1)
MACH_TARGETS = 
MACH_OBJS    = 
endif

all: $(OBJS) $(TARGETS)
	@:

debug:
	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb -nopie" clean all
	@-/sbin/chpax  -permsx $(ELF_TARGETS)
	@-/sbin/paxctl -permsx $(ELF_TARGETS)

compile.c = $(CC) $(CFLAGS) $(CPPFLAGS) $(CPPFLAGS-$<) -o $@ -c $<

ifeq ($(V),)
Q := @
else
Q :=
endif
%.o: %.c
ifeq ($(V),)
	@echo $(compile.c)
endif
	$(Q)$(compile.c) $(WFLAGS)

$(ELF_TARGETS): $(ELF_OBJS) paxinc.o
	$(CC) $(CFLAGS) $(LDFLAGS) paxinc.o paxelf.o -o $@ $@.o $(LIBS) $(LIBS-$@)

$(MACH_TARGETS): $(MACH_OBJS) paxinc.o
	$(CC) $(CFLAGS) $(LDFLAGS) paxinc.o paxmacho.o -o $@ $@.o $(LIBS) $(LIBS-$@)

%.so: %.c
	$(CC) -shared -fPIC -o $@ $<

depend:
	$(CC) $(CFLAGS) -MM $(SOURCES) > .depend

clean:
	-rm -f $(OBJS) $(TARGETS)

distclean: clean
	-rm -f *~ core *.o

strip: all
	$(STRIP) $(TARGETS)
strip-more:
	$(STRIP) --strip-unneeded $(TARGETS)

install: all
	-$(MKDIR) $(PREFIX)/bin/ $(PREFIX)/share/man/man1/
	$(CP) $(TARGETS) $(PREFIX)/bin/
ifeq ($(S),)
	-$(MKDIR) $(PREFIX)/share/doc/pax-utils/
	$(CP) README BUGS TODO $(PREFIX)/share/doc/pax-utils/
endif
	for mpage in $(MPAGES) ; do \
		[ -e $$mpage ] \
			&& cp $$mpage $(PREFIX)/share/man/man1/ || : ;\
	done

dist: distclean
	@tempfiles=`ls .#* *.o 2>/dev/null` ; \
	if [ -n "$$tempfiles" ] ; then \
		echo "Please remove these files first:" ; \
		echo "$$tempfiles" ; \
		exit 1 ; \
	fi
	@if [ "$(PV)" = "" ] ; then \
		echo "Please run 'make dist PV=<ver>'" ; \
		exit 1 ; \
	fi
	$(MAKE) -s distclean
	rm -rf ../pax-utils-$(PV)*
	mkdir ../pax-utils-$(PV)
	cp -R * .depend ../pax-utils-$(PV)/
	rm -rf ../pax-utils-$(PV)/CVS ../pax-utils-$(PV)/*/CVS ../pax-utils-$(PV)/make-tarball.sh
	tar jcf ../pax-utils-$(PV).tar.bz2 -C .. pax-utils-$(PV)
	rm -rf ../pax-utils-$(PV)
	du -b ../pax-utils-$(PV).tar.bz2

-include .depend

## pax-utils 0.1.15

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-# Copyright 2003 Ned Ludd <solar@linbsd.net>
+# Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.55 2006/05/14 05:52:46 vapier Exp $
+# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.57 2006/07/25 17:21:02 solar Exp $
 ####################################################################
 
 check_gcc=$(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
@@ -16,7 +16,7 @@
              $(call check-gcc, -Wextra)
 
 CFLAGS    ?= -O2 -pipe
-CPPFLAGS  += -D_GNU_SOURCE
+override CPPFLAGS  += -D_GNU_SOURCE
 LDFLAGS   +=
 LIBS      :=
 DESTDIR    =
@@ -35,7 +35,7 @@
 endif
 
 ifdef PV
-CPPFLAGS  += -DVERSION=\"$(PV)\"
+override CPPFLAGS  += -DVERSION=\"$(PV)\"
 endif
 
 ####################################################################

## pax-utils 0.1.16

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.57 2006/07/25 17:21:02 solar Exp $
+# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.64 2007/08/20 09:54:15 vapier Exp $
 ####################################################################
 
 check_gcc=$(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
@@ -39,11 +39,12 @@
 endif
 
 ####################################################################
-ELF_TARGETS  = scanelf pspax dumpelf
+ELF_TARGETS  = scanelf dumpelf $(shell echo | $(CC) -dM -E - | grep -q __svr4__ || echo pspax)
 ELF_OBJS     = $(ELF_TARGETS:%=%.o) paxelf.o
 MACH_TARGETS = scanmacho
 MACH_OBJS    = $(MACH_TARGETS:%=%.o) paxmacho.o
-OBJS         = $(ELF_OBJS) $(MACH_OBJS) paxinc.o
+COMMON_OBJS  = paxinc.o xfuncs.o
+OBJS         = $(ELF_OBJS) $(MACH_OBJS) $(COMMON_OBJS)
 TARGETS      = $(ELF_TARGETS) $(MACH_TARGETS)
 MPAGES       = $(TARGETS:%=man/%.1)
 SOURCES      = $(OBJS:%.o=%.c)
@@ -74,11 +75,11 @@
 endif
 	$(Q)$(compile.c) $(WFLAGS)
 
-$(ELF_TARGETS): $(ELF_OBJS) paxinc.o
-	$(CC) $(CFLAGS) $(LDFLAGS) paxinc.o paxelf.o -o $@ $@.o $(LIBS) $(LIBS-$@)
+$(ELF_TARGETS): $(ELF_OBJS) $(COMMON_OBJS)
+	$(CC) $(CFLAGS) $(LDFLAGS) $(COMMON_OBJS) paxelf.o -o $@ $@.o $(LIBS) $(LIBS-$@)
 
-$(MACH_TARGETS): $(MACH_OBJS) paxinc.o
-	$(CC) $(CFLAGS) $(LDFLAGS) paxinc.o paxmacho.o -o $@ $@.o $(LIBS) $(LIBS-$@)
+$(MACH_TARGETS): $(MACH_OBJS) $(COMMON_OBJS)
+	$(CC) $(CFLAGS) $(LDFLAGS) $(COMMON_OBJS) paxmacho.o -o $@ $@.o $(LIBS) $(LIBS-$@)
 
 %.so: %.c
 	$(CC) -shared -fPIC -o $@ $<
@@ -91,7 +92,7 @@
 
 distclean: clean
 	-rm -f *~ core *.o
-
+	-cd man && $(MAKE) clean
 strip: all
 	$(STRIP) $(TARGETS)
 strip-more:
@@ -105,7 +106,7 @@
 	$(CP) README BUGS TODO $(PREFIX)/share/doc/pax-utils/
 endif
 	for mpage in $(MPAGES) ; do \
-		[ -e $$mpage ] \
+		[ -f $$mpage ] \
 			&& cp $$mpage $(PREFIX)/share/man/man1/ || : ;\
 	done
 
@@ -121,12 +122,17 @@
 		exit 1 ; \
 	fi
 	$(MAKE) -s distclean
+	echo "<releaseinfo>$(PV)</releaseinfo>" > man/fragment/version
+	$(MAKE) -C man
 	rm -rf ../pax-utils-$(PV)*
-	mkdir ../pax-utils-$(PV)
-	cp -R * .depend ../pax-utils-$(PV)/
-	rm -rf ../pax-utils-$(PV)/CVS ../pax-utils-$(PV)/*/CVS ../pax-utils-$(PV)/make-tarball.sh
+	rsync -a --exclude=CVS --exclude='*macho*' . ../pax-utils-$(PV)
 	tar jcf ../pax-utils-$(PV).tar.bz2 -C .. pax-utils-$(PV)
 	rm -rf ../pax-utils-$(PV)
 	du -b ../pax-utils-$(PV).tar.bz2
 
 -include .depend
+
+check test:
+	$(MAKE) -C tests
+
+.PHONY: all check clean dist install test

=== man/Makefile ===
all: man

XMLTO_FLAGS_man = -x custom.xsl
man pdf txt xhtml xhtml-nochunks:
	@echo "If this fails, you probably need to emerge ~app-text/docbook-xml-dtd-4.4"
	xmlto $@ $(XMLTO_FLAGS_$@) pax-utils.docbook

clean distclean:
	rm -f *.1 *.html

.PHONY: all clean distclean \
        man pdf txt xhtml xhtml-nochunks

## pax-utils 0.1.16-3

=== debian/changelog ===
pax-utils (0.1.16-3) unstable; urgency=low

  * Ported to maemo removing some not necessarily dependencies.

 -- Felipe Zimmerle <felipe.zimmerle@collabora.co.uk>  Wed, 30 Dec 2009 20:20:20 +0300

pax-utils (0.1.16-2) unstable; urgency=low

  * Switch to libcap2-dev. (Closes: #492640)
  * Update standards version to 3.8.0.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Sat, 02 Aug 2008 22:19:07 +0300

pax-utils (0.1.16-1) unstable; urgency=low

  * New upstream version.
  * Added Homepage debian/control header.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Wed, 17 Oct 2007 18:39:39 +0300

pax-utils (0.1.15-2) unstable; urgency=low

  * Added XS-Vcs-Svn field.
  * Update standards version to 3.7.2.2.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Sun, 03 Jun 2007 22:46:34 +0300

pax-utils (0.1.15-1) unstable; urgency=low

  * New upstream version:
   - no non-DFSG content anymore,
   - _GNU_SOURCE fix no longer needed.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Wed, 13 Dec 2006 16:26:56 +0100

pax-utils (0.1.13.dfsg.1-2) unstable; urgency=low

  * Don't build-depends on libcap-dev on Hurd and kFreeBSD.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Fri,  6 Oct 2006 17:51:17 +0300

pax-utils (0.1.13.dfsg.1-1) unstable; urgency=low

  * Initial Debian package (Closes: #388200).
  * Remove original macho.h with Apple copyright but no license.

 -- Rémi Denis-Courmont <rdenis@simphalempin.com>  Tue, 19 Sep 2006 17:34:40 +0300

=== debian/control ===
Source: pax-utils
Section: misc
Priority: extra
Maintainer: Felipe Zimmerle <felipe.zimmerle@collabora.co.uk>
Build-Depends: cdbs, debhelper (>= 4.1.0)
Standards-Version: 3.8.0
Homepage: http://dev.gentoo.org/~solar/pax-utils/
XS-Vcs-Svn: http://anonsvn.remlab.net/svn/pkg-remlab/pax-utils

Package: pax-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: chpax
Description: Security-focused ELF files checking tool
 This is a small set of various PaX aware and related utilities for ELF
 binaries. It can check ELF binary files and running processes for
 issues that might be relevant when using ELF binaries along with PaX,
 such as non-PIC code or executable stack and heap.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_MAKE_INSTALL_TARGET := install DESTDIR=$(CURDIR)/debian/pax-utils/

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://dev.gentoo.org/~solar/pax/ pax-utils-(.*\..*).tar.bz2

## pax-utils 0.2.2

=== debian/changelog ===
pax-utils (0.2.2-1) unstable; urgency=low

  * New upstream release.                                       closes: #605375
  * Adopt the package, thanks Rémi for the previous work.       closes: #600958
  * debian/control:
    - update debhelper build-dep to 7.0.50~ (for overrides).
    - update standards version to 3.9.1.
    - drop cdbs build-dep.
  * debian/compat bumped to 7.
  * Switch to 3.0 (quilt) source format.
  * debian/rules:
    - switch to dh7 tiny rules.
    - pick {C,LD}FLAGS from dpkg-buildflags.
    - add hardening flags to {C,LD}FLAGS.
    - add --as-needed, -O1 and -z,defs to LDFLAGS.
    - override dh_auto_test since there's no tests available.
    - override dh_auto_clean which will call distclean first and remove the
      manpages.
  * debian/watch updated to the new upstream repository.

 -- Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>  Sun, 20 Feb 2011 16:58:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: pax-utils
 Section: misc
 Priority: extra
-Maintainer: Felipe Zimmerle <felipe.zimmerle@collabora.co.uk>
-Build-Depends: cdbs, debhelper (>= 4.1.0)
-Standards-Version: 3.8.0
+Maintainer: Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>
+Build-Depends: debhelper (>= 7.0.50~), hardening-includes,
+ libcap2-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
+Standards-Version: 3.9.1
 Homepage: http://dev.gentoo.org/~solar/pax-utils/
 XS-Vcs-Svn: http://anonsvn.remlab.net/svn/pkg-remlab/pax-utils

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/hardening-includes/hardening.make

CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS+=$(HARDENING_LDFLAGS) -Wl,-z,defs -Wl,--as-needed -Wl,-O1
CFLAGS+=$(HARDENING_CFLAGS)

export CFLAGS LDFLAGS

ifeq ($(DEB_HOST_ARCH_OS),linux)
USE_CAP=yes
export USE_CAP
endif

override_dh_auto_test:

override_dh_auto_clean:
	make clean || true

%:
	dh $@

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://dev.gentoo.org/~vapier/dist/ pax-utils-(.*\..*).tar.bz2

## pax-utils 0.2.3

=== Makefile ===
# Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.75 2010/06/08 05:51:31 vapier Exp $
####################################################################

check_gcc=$(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
	then echo "$(1)"; else echo "$(2)"; fi)

####################################################################
# Avoid CC overhead when installing
ifneq ($(MAKECMDGOALS),install)
WFLAGS    := -Wall -Wunused -Wimplicit -Wshadow -Wformat=2 \
             -Wmissing-declarations -Wmissing-prototypes -Wwrite-strings \
             -Wbad-function-cast -Wnested-externs -Wcomment -Winline \
             -Wchar-subscripts -Wcast-align -Wno-format-nonliteral \
             $(call check_gcc, -Wdeclaration-after-statement) \
             $(call check-gcc, -Wsequence-point) \
             $(call check-gcc, -Wstrict-overflow) \
             $(call check-gcc, -Wextra)
endif

CFLAGS    ?= -O2 -pipe
override CPPFLAGS  += -D_GNU_SOURCE
LDFLAGS   +=
LIBS      :=
DESTDIR    =
PREFIX    := $(DESTDIR)/usr
STRIP     := strip
MKDIR     := mkdir -p
CP        := cp
INS_EXE   := install -m755
INS_DATA  := install -m644

# Some fun settings
#CFLAGS   += -DEBUG -g
#LDFLAGS  += -pie

ifeq ($(USE_CAP),yes)
CPPFLAGS-pspax.c += -DWANT_SYSCAP
LIBS-pspax       += -lcap
endif

ifdef PV
override CPPFLAGS  += -DVERSION=\"$(PV)\"
endif

####################################################################
ELF_TARGETS  = scanelf dumpelf $(shell echo | $(CC) -dM -E - | grep -q __svr4__ || echo pspax)
ELF_OBJS     = paxelf.o
MACH_TARGETS = scanmacho
MACH_OBJS    = paxmacho.o
COMMON_OBJS  = paxinc.o xfuncs.o
TARGETS      = $(ELF_TARGETS) $(MACH_TARGETS)
OBJS         = $(ELF_OBJS) $(MACH_OBJS) $(COMMON_OBJS) $(TARGETS:%=%.o)
MPAGES       = $(TARGETS:%=man/%.1)
SOURCES      = $(OBJS:%.o=%.c)

all: $(OBJS) $(TARGETS)
	@:

debug:
	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb $(call check-gcc,-nopie)" clean all
	@-/sbin/chpax  -permsx $(ELF_TARGETS)
	@-/sbin/paxctl -permsx $(ELF_TARGETS)

compile.c = $(CC) $(CFLAGS) $(CPPFLAGS) $(CPPFLAGS-$<) -o $@ -c $<

ifeq ($(V),)
Q := @
else
Q :=
endif
%.o: %.c
ifeq ($(V),)
	@echo $(compile.c)
endif
	$(Q)$(compile.c) $(WFLAGS)

$(ELF_TARGETS): %: $(ELF_OBJS) $(COMMON_OBJS) %.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@ $(LIBS) $(LIBS-$@)

$(MACH_TARGETS): %: $(MACH_OBJS) $(COMMON_OBJS) %.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@ $(LIBS) $(LIBS-$@)

%.so: %.c
	$(CC) -shared -fPIC -o $@ $<

depend:
	$(CC) $(CFLAGS) -MM $(SOURCES) > .depend

clean:
	-rm -f $(OBJS) $(TARGETS)

distclean: clean
	-rm -f *~ core *.o
	-cd man && $(MAKE) clean
strip: all
	$(STRIP) $(TARGETS)
strip-more:
	$(STRIP) --strip-unneeded $(TARGETS)

install: all
	$(MKDIR) $(PREFIX)/bin/ $(PREFIX)/share/man/man1/
	for sh in *.sh ; do $(INS_EXE) $$sh $(PREFIX)/bin/$${sh%.sh} || exit $$? ; done
	$(INS_EXE) $(TARGETS) $(PREFIX)/bin/
ifeq ($(S),)
	$(MKDIR) $(PREFIX)/share/doc/pax-utils/
	$(CP) README BUGS TODO $(PREFIX)/share/doc/pax-utils/
	-$(INS_DATA) $(MPAGES) $(PREFIX)/share/man/man1/
else
	$(INS_DATA) $(MPAGES) $(PREFIX)/share/man/man1/
endif

dist:
	@if [ "$(PV)" = "" ] ; then \
		echo "Please run 'make dist PV=<ver>'" ; \
		exit 1 ; \
	fi
	rm -rf pax-utils-$(PV)
	mkdir pax-utils-$(PV)
	cp -a CVS pax-utils-$(PV)/
	cd pax-utils-$(PV) && cvs up
	echo "<releaseinfo>$(PV)</releaseinfo>" > pax-utils-$(PV)/man/fragment/version
	$(MAKE) -C pax-utils-$(PV)/man
	tar jcf pax-utils-$(PV).tar.bz2 pax-utils-$(PV) --exclude=CVS --exclude=.cvsignore
	@printf "\n ..... Making sure clean cvs build works ..... \n\n"
	unset CFLAGS; \
	for t in all check clean debug check ; do \
		$(MAKE) -C pax-utils-$(PV) $$t || exit $$? ; \
	done
	rm -rf pax-utils-$(PV)
	du -b pax-utils-$(PV).tar.bz2

-include .depend

check test:
	$(MAKE) -C tests

.PHONY: all check clean dist install test

=== man/Makefile ===
all: man

XMLTO_FLAGS_man = -x custom.xsl --skip-validation
man pdf txt xhtml xhtml-nochunks:
	@xmlto $@ $(XMLTO_FLAGS_$@) pax-utils.docbook || echo "If this failed, you probably need to emerge ~app-text/docbook-xml-dtd-4.4 app-text/xmlto dev-tex/xmltex"
	@# scanelf.1 has funky indented lists ... hack it back
	@sed -i 's:^[.]TP 4:.TP 2:' scanelf.1
clean distclean:
	rm -f *.1 *.html

.PHONY: all clean distclean \
        man pdf txt xhtml xhtml-nochunks

=== tests/Makefile ===
SUBDIRS = $(patsubst %/Makefile,%,$(wildcard */Makefile))

.PHONY: all test check clean
all test check clean:
	$(MAKE) $(patsubst %,subdir_%_$@,$(SUBDIRS))

# subdir_source_all
_SUBTAR = $(patsubst subdir_%,%,$@)
_SUBDIR = $(shell expr $(_SUBTAR) : '\(.*\)_[^_]*$$')
_TARGET = $(shell expr $(_SUBTAR) : '.*_\([^_]*\)$$')
subdir_%:
	$(MAKE) -C $(_SUBDIR) $(_TARGET)

=== debian/changelog ===
pax-utils (0.2.3-2build2) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:04:11 -0700

pax-utils (0.2.3-2build1) precise; urgency=low

  * Rebuild with dpkg 1.16.1.1ubuntu2 to restore full hardening support.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 01 Nov 2011 17:16:55 -0400

pax-utils (0.2.3-2) unstable; urgency=low

  * debian/rules:
    - don't disable tests.
    - switch to dpkg-dev 1.16.1 hardening flags support
  * debian/control:
    - add build-dep on python, needed for running test suite.
    - drop hardening-includes build-dep, add build-dep on dpkg-dev (>= 1.16.1)
      and update debhelper build-dep for compat mode 9.
  * debian/compat bumped to 9.
  * debian/patches:
    - 01_fix-endianness-hurd added, fix include leading to endianness problems
      on hurd-i386. Thanks Pino Toscano!                        closes: #644607

 -- Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>  Sat, 08 Oct 2011 14:55:33 +0200

pax-utils (0.2.3-1) unstable; urgency=low

  * New upstream release.
  * debian/watch updated to track .xz tarballs.

 -- Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>  Thu, 06 Oct 2011 22:58:27 +0200

pax-utils (0.2.2-2) unstable; urgency=low

  * debian/control:
    - replace chpax by paxctl in suggests.
    - use linux-any in libcap-dev build-dep.                    closes: #634786
    - update standards version to 3.9.2.

 -- Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>  Wed, 03 Aug 2011 08:33:21 +0200

=== debian/control ===
Source: pax-utils
Section: misc
Priority: extra
Maintainer: Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.3), 
 libcap2-dev [linux-any], python
Standards-Version: 3.9.2
Homepage: http://dev.gentoo.org/~solar/pax-utils/
XS-Vcs-Svn: http://anonsvn.remlab.net/svn/pkg-remlab/pax-utils

Package: pax-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: paxctl
Description: Security-focused ELF files checking tool
 This is a small set of various PaX aware and related utilities for ELF
 binaries. It can check ELF binary files and running processes for
 issues that might be relevant when using ELF binaries along with PaX,
 such as non-PIC code or executable stack and heap.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,-z,defs -Wl,--as-needed -Wl,-O1
export DEB_BUILD_MAINT_OPTIONS=hardening=+pie,+bindnow

ifeq ($(DEB_HOST_ARCH_OS),linux)
USE_CAP=yes
export USE_CAP
endif

override_dh_auto_clean:
	make clean || true

%:
	dh $@

## pax-utils 0.8.1

=== Makefile ===
# Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.83 2013/05/23 00:09:01 vapier Exp $
####################################################################

check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
	then echo "$(1)"; else echo "$(2)"; fi)
check_gcc_many = $(foreach flag,$(1),$(call check_gcc,$(flag)))

####################################################################
# Avoid CC overhead when installing
ifneq ($(MAKECMDGOALS),install)
_WFLAGS   := \
	-Wdeclaration-after-statement \
	-Wextra \
	-Wsequence-point \
	-Wstrict-overflow
WFLAGS    := -Wall -Wunused -Wimplicit -Wshadow -Wformat=2 \
             -Wmissing-declarations -Wmissing-prototypes -Wwrite-strings \
             -Wbad-function-cast -Wnested-externs -Wcomment -Winline \
             -Wchar-subscripts -Wcast-align -Wno-format-nonliteral \
             $(call check_gcc_many,$(_WFLAGS))
endif

CFLAGS    ?= -O2 -pipe
override CPPFLAGS  += -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
LDFLAGS   +=
LIBS      :=
DESTDIR    =
PREFIX     = $(DESTDIR)/usr
DATADIR    = $(PREFIX)/share
MANDIR     = $(DATADIR)/man
DOCDIR     = $(DATADIR)/doc
PKGDOCDIR  = $(DOCDIR)/pax-utils
STRIP     := strip
MKDIR     := mkdir -p
INS_EXE   := install -m755
INS_DATA  := install -m644

# Some fun settings
#CFLAGS   += -DEBUG -g
#LDFLAGS  += -pie

ifeq ($(USE_CAP),yes)
CPPFLAGS-pspax.c += -DWANT_SYSCAP
LIBS-pspax       += -lcap
endif

ifdef PV
override CPPFLAGS  += -DVERSION=\"$(PV)\"
endif

####################################################################
ELF_TARGETS  = scanelf dumpelf $(shell echo | $(CC) -dM -E - | grep -q __svr4__ || echo pspax)
ELF_OBJS     = paxelf.o
MACH_TARGETS = scanmacho
MACH_OBJS    = paxmacho.o
COMMON_OBJS  = paxinc.o xfuncs.o
TARGETS      = $(ELF_TARGETS) $(MACH_TARGETS)
OBJS         = $(ELF_OBJS) $(MACH_OBJS) $(COMMON_OBJS) $(TARGETS:%=%.o)
MPAGES       = $(TARGETS:%=man/%.1)
SOURCES      = $(OBJS:%.o=%.c)

all: $(OBJS) $(TARGETS)
	@:

DEBUG_FLAGS = \
	-nopie \
	-fsanitize=address
debug: clean
	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb $(call check_gcc_many,$(DEBUG_FLAGS))" all
	@-chpax  -permsx $(ELF_TARGETS)
	@-paxctl -permsx $(ELF_TARGETS)

compile.c = $(CC) $(CFLAGS) $(CPPFLAGS) $(CPPFLAGS-$<) -o $@ -c $<

ifeq ($(V),)
Q := @
else
Q :=
endif
%.o: %.c
ifeq ($(V),)
	@echo $(compile.c)
endif
	$(Q)$(compile.c) $(WFLAGS)

$(ELF_TARGETS): %: $(ELF_OBJS) $(COMMON_OBJS) %.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@ $(LIBS) $(LIBS-$@)

$(MACH_TARGETS): %: $(MACH_OBJS) $(COMMON_OBJS) %.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@ $(LIBS) $(LIBS-$@)

%.so: %.c
	$(CC) -shared -fPIC -o $@ $<

depend:
	$(CC) $(CFLAGS) -MM $(SOURCES) > .depend

clean:
	-rm -f $(OBJS) $(TARGETS)

distclean: clean
	-rm -f *~ core *.o
	-cd man && $(MAKE) clean
strip: all
	$(STRIP) $(TARGETS)
strip-more:
	$(STRIP) --strip-unneeded $(TARGETS)

install: all
	$(MKDIR) $(PREFIX)/bin/ $(MANDIR)/man1/ $(PKGDOCDIR)/
	for sh in *.sh ; do $(INS_EXE) $$sh $(PREFIX)/bin/$${sh%.sh} || exit $$? ; done
ifeq ($(USE_PYTHON),yes)
	for py in *.py ; do $(INS_EXE) $$py $(PREFIX)/bin/$${py%.py} || exit $$? ; done
endif
	$(INS_EXE) $(TARGETS) $(PREFIX)/bin/
	$(INS_DATA) README BUGS TODO $(PKGDOCDIR)/
	$(INS_DATA) $(MPAGES) $(MANDIR)/man1/

PN = pax-utils
P = $(PN)-$(PV)
dist:
	@if [ "$(PV)" = "" ] ; then \
		echo "Please run 'make dist PV=<ver>'" ; \
		exit 1 ; \
	fi
	rm -rf $(P)
	mkdir $(P)
	cp -a CVS $(P)/
	cd $(P) && cvs up
	echo "<releaseinfo>$(PV)</releaseinfo>" > $(P)/man/fragment/version
	$(MAKE) -C $(P)/man
	tar cf - $(P) --exclude=CVS --exclude=.cvsignore | xz > $(P).tar.xz
	@printf "\n ..... Making sure clean cvs build works ..... \n\n"
	unset CFLAGS; \
	for t in all check clean debug check ; do \
		$(MAKE) -C $(P) $$t || exit $$? ; \
	done
	rm -rf $(P)
	du -b $(P).tar.xz

-include .depend

check test:
	$(MAKE) -C tests

.PHONY: all check clean dist install test

=== tests/Makefile ===
SUBDIRS = $(patsubst %/Makefile,%,$(wildcard */Makefile))
# DO NOT STARE AT THE SUN
all:
%:; $(MAKE) `printf '%s_$@_ ' $(SUBDIRS)`
_words = $(subst _, ,$1)
_dir = $(firstword $(call _words,$@))
_targ = $(lastword $(call _words,$@))
%_:; $(MAKE) -C $(_dir) $(_targ)

=== tests/lddtree/Makefile ===
all: check

%.check:
	./dotest.$(@:.check=)

test check: sh.check
ifeq ($(USE_PYTHON),yes)
test check: py.check cmp.check
endif

clean:

.PHONY: all check clean test

=== debian/changelog ===
pax-utils (0.8.1-1) unstable; urgency=medium

  * Imported Upstream version 0.8.1 (Closes: #755907)
  * Updates to debian/* files
  * New maintainer (thanks Yves-Alexis!)

 -- Tomasz Buchert <tomasz.buchert@inria.fr>  Mon, 22 Sep 2014 14:30:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: pax-utils
 Section: misc
 Priority: extra
-Maintainer: Yves-Alexis Perez <yves-alexis.perez@ssi.gouv.fr>
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.3), 
- libcap2-dev [linux-any], python
-Standards-Version: 3.9.2
+Maintainer: Tomasz Buchert <tomasz.buchert@inria.fr>
+Build-Depends: debhelper (>= 9), libcap2-dev [linux-any], python
+Standards-Version: 3.9.5
 Homepage: http://dev.gentoo.org/~solar/pax-utils/
-XS-Vcs-Svn: http://anonsvn.remlab.net/svn/pkg-remlab/pax-utils
+Vcs-Git: git://anonscm.debian.org/collab-maint/pax-utils.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pax-utils.git
 
 Package: pax-utils
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS  = hardening=+pie,+bindnow

ifeq ($(DEB_HOST_ARCH_OS),linux)
	# pspax.c on Linux can use sys/capability.h
	# to get nice textual representations
	USE_CAP=yes
	export USE_CAP
endif

override_dh_auto_clean:
	# overridden, because otherwise "make distclean" is run
	# which deletes too many files
	make clean || true

%:
	dh $@

## pax-utils 1.0.5

=== debian/changelog ===
pax-utils (1.0.5-1) unstable; urgency=medium

  * Imported Upstream version 1.0.5
  * Fix tests (Closes: #793010)

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 31 Jul 2015 15:58:59 +0200

pax-utils (1.0.4-1) unstable; urgency=medium

  * Imported Upstream version 1.0.4
  * Use dh-autoreconf

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 19 Jul 2015 19:00:34 +0200

pax-utils (1.0.3-2) unstable; urgency=medium

  * Enable tests during the build
  * Clean and update files
  * Drop obsolete lintian overrides

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 11 Jul 2015 12:17:47 +0200

pax-utils (1.0.3-1) unstable; urgency=medium

  * Imported Upstream version 1.0.3

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 08 Apr 2015 01:06:58 +0200

pax-utils (1.0.2-1) unstable; urgency=medium

  * Imported Upstream version 1.0.2

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 20 Mar 2015 14:27:13 +0100

pax-utils (1.0.1-1) unstable; urgency=medium

  * Fix reproducibility problem (Closes: #776715)
  * Bump Standards-Version to 3.9.6 (no changes required)
  * Correct lintian warnings
  * Skip the tests (temporary workaround)
  * Imported Upstream version 1.0.1

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 08 Mar 2015 19:42:52 +0100

=== debian/control ===
Source: pax-utils
Section: misc
Priority: extra
Maintainer: Tomasz Buchert <tomasz@debian.org>
Build-Depends: debhelper (>= 9),
               libcap2-dev [linux-any],
               python,
               python-pyelftools,
               dh-autoreconf,
               autoconf-archive,
               gnulib
Standards-Version: 3.9.6
Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities
Vcs-Git: git://anonscm.debian.org/collab-maint/pax-utils.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pax-utils.git

Package: pax-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: paxctl
Description: Security-focused ELF files checking tool
 This is a small set of various PaX aware and related utilities for ELF
 binaries. It can check ELF binary files and running processes for
 issues that might be relevant when using ELF binaries along with PaX,
 such as non-PIC code or executable stack and heap.

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,7 @@
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 	# pspax.c on Linux can use sys/capability.h
 	# to get nice textual representations
-	USE_CAP=yes
-	export USE_CAP
+	export USE_CAP=yes
 endif
 
 override_dh_auto_clean:
@@ -15,5 +14,8 @@
 	# which deletes too many files
 	make clean || true
 
+override_dh_autoreconf:
+	dh_autoreconf debian/autogen.sh
+
 %:
-	dh $@
+	dh $@ --with autoreconf

## pax-utils 1.1.5

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
+PV := v1.1.5
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-projects/pax-utils/Makefile,v 1.83 2013/05/23 00:09:01 vapier Exp $
 ####################################################################
 
 check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
@@ -14,7 +14,8 @@
 	-Wdeclaration-after-statement \
 	-Wextra \
 	-Wsequence-point \
-	-Wstrict-overflow
+	-Wstrict-overflow \
+	-Wmisleading-indentation
 WFLAGS    := -Wall -Wunused -Wimplicit -Wshadow -Wformat=2 \
              -Wmissing-declarations -Wmissing-prototypes -Wwrite-strings \
              -Wbad-function-cast -Wnested-externs -Wcomment -Winline \
@@ -37,26 +38,42 @@
 INS_EXE   := install -m755
 INS_DATA  := install -m644
 
-# Some fun settings
-#CFLAGS   += -DEBUG -g
-#LDFLAGS  += -pie
+PKG_CONFIG ?= pkg-config
 
 ifeq ($(USE_CAP),yes)
-CPPFLAGS-pspax.c += -DWANT_SYSCAP
-LIBS-pspax       += -lcap
+LIBCAPS_CFLAGS := $(shell $(PKG_CONFIG) --cflags libcap)
+LIBCAPS_LIBS   := $(shell $(PKG_CONFIG) --libs libcap)
+CPPFLAGS-pspax.c += $(LIBCAPS_CFLAGS) -DWANT_SYSCAP
+LIBS-pspax       += $(LIBCAPS_LIBS)
+endif
+
+ifeq ($(USE_DEBUG),yes)
+override CPPFLAGS += -DEBUG
+endif
+
+ifeq ($(USE_SECCOMP),yes)
+LIBSECCOMP_CFLAGS := $(shell $(PKG_CONFIG) --cflags libseccomp)
+LIBSECCOMP_LIBS   := $(shell $(PKG_CONFIG) --libs libseccomp)
+override CPPFLAGS += $(LIBSECCOMP_CFLAGS) -DWANT_SECCOMP
+LIBS              += $(LIBSECCOMP_LIBS)
 endif
 
 ifdef PV
 override CPPFLAGS  += -DVERSION=\"$(PV)\"
+else
+VCSID     := $(shell git describe --tags HEAD)
 endif
+override CPPFLAGS  += -DVCSID='"$(VCSID)"'
 
 ####################################################################
 ELF_TARGETS  = scanelf dumpelf $(shell echo | $(CC) -dM -E - | grep -q __svr4__ || echo pspax)
 ELF_OBJS     = paxelf.o
 MACH_TARGETS = scanmacho
 MACH_OBJS    = paxmacho.o
-COMMON_OBJS  = paxinc.o xfuncs.o
+COMMON_OBJS  = paxinc.o security.o xfuncs.o
 TARGETS      = $(ELF_TARGETS) $(MACH_TARGETS)
+SCRIPTS_SH   = lddtree symtree
+SCRIPTS_PY   = lddtree
 OBJS         = $(ELF_OBJS) $(MACH_OBJS) $(COMMON_OBJS) $(TARGETS:%=%.o)
 MPAGES       = $(TARGETS:%=man/%.1)
 SOURCES      = $(OBJS:%.o=%.c)
@@ -66,11 +83,22 @@
 
 DEBUG_FLAGS = \
 	-nopie \
-	-fsanitize=address
+	-fsanitize=address \
+	-fsanitize=leak \
+	-fsanitize=undefined
 debug: clean
 	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb $(call check_gcc_many,$(DEBUG_FLAGS))" all
 	@-chpax  -permsx $(ELF_TARGETS)
 	@-paxctl -permsx $(ELF_TARGETS)
+
+analyze: clean
+	scan-build $(MAKE) all
+
+fuzz: clean
+	$(MAKE) AFL_HARDEN=1 CC=afl-gcc all
+	@rm -rf findings
+	@printf '\nNow run:\n%s\n' \
+		"afl-fuzz -t 100 -i tests/fuzz/small/ -o findings/ ./scanelf -s '*' -axetrnibSDIYZB @@"
 
 compile.c = $(CC) $(CFLAGS) $(CPPFLAGS) $(CPPFLAGS-$<) -o $@ -c $<
 
@@ -110,35 +138,20 @@
 
 install: all
 	$(MKDIR) $(PREFIX)/bin/ $(MANDIR)/man1/ $(PKGDOCDIR)/
-	for sh in *.sh ; do $(INS_EXE) $$sh $(PREFIX)/bin/$${sh%.sh} || exit $$? ; done
-ifeq ($(USE_PYTHON),yes)
-	for py in *.py ; do $(INS_EXE) $$py $(PREFIX)/bin/$${py%.py} || exit $$? ; done
+	for sh in $(SCRIPTS_SH) ; do $(INS_EXE) $$sh.sh $(PREFIX)/bin/$$sh || exit $$? ; done
+ifneq ($(USE_PYTHON),no)
+	for py in $(SCRIPTS_PY) ; do $(INS_EXE) $$py.py $(PREFIX)/bin/$$py || exit $$? ; done
 endif
 	$(INS_EXE) $(TARGETS) $(PREFIX)/bin/
-	$(INS_DATA) README BUGS TODO $(PKGDOCDIR)/
+	$(INS_DATA) README.md BUGS TODO $(PKGDOCDIR)/
 	$(INS_DATA) $(MPAGES) $(MANDIR)/man1/
 
 PN = pax-utils
 P = $(PN)-$(PV)
 dist:
-	@if [ "$(PV)" = "" ] ; then \
-		echo "Please run 'make dist PV=<ver>'" ; \
-		exit 1 ; \
-	fi
-	rm -rf $(P)
-	mkdir $(P)
-	cp -a CVS $(P)/
-	cd $(P) && cvs up
-	echo "<releaseinfo>$(PV)</releaseinfo>" > $(P)/man/fragment/version
-	$(MAKE) -C $(P)/man
-	tar cf - $(P) --exclude=CVS --exclude=.cvsignore | xz > $(P).tar.xz
-	@printf "\n ..... Making sure clean cvs build works ..... \n\n"
-	unset CFLAGS; \
-	for t in all check clean debug check ; do \
-		$(MAKE) -C $(P) $$t || exit $$? ; \
-	done
-	rm -rf $(P)
-	du -b $(P).tar.xz
+	./make-tarball.sh $(DISTCHECK) $(PV)
+distcheck:
+	$(MAKE) dist DISTCHECK=--check
 
 -include .depend
 
@@ -146,3 +159,31 @@
 	$(MAKE) -C tests
 
 .PHONY: all check clean dist install test
+
+#
+# All logic related to autotools is below here
+#
+GEN_MARK_START = \# @@@ GEN START @@@ \#
+GEN_MARK_END   = \# @@@ GEN END @@@ \#
+EXTRA_DIST     = $(shell git ls-files | grep -v ^travis/)
+autotools-update:
+	$(MAKE) -C man -j
+	sed -i.tmp '/^$(GEN_MARK_START)$$/,/^$(GEN_MARK_END)$$/d' Makefile.am
+	@rm -f Makefile.am.tmp
+	( \
+		echo "$(GEN_MARK_START)"; \
+		printf 'dist_man_MANS +='; \
+		printf ' \\\n\t%s' `printf '%s\n' man/*.1 | LC_ALL=C sort`; \
+		echo; \
+		printf 'EXTRA_DIST +='; \
+		printf ' \\\n\t%s' $(EXTRA_DIST); \
+		echo; \
+		echo "$(GEN_MARK_END)"; \
+	) >> Makefile.am
+autotools:
+ifeq ($(SKIP_AUTOTOOLS_UPDATE),)
+	$(MAKE) autotools-update
+endif
+	./autogen.sh --from=make
+
+.PHONY: autotools autotools-update _autotools-update

=== tests/source/Makefile ===
all: check

test check:
	./dotest

clean:

.PHONY: all check clean test

=== debian/changelog ===
pax-utils (1.1.5-1) unstable; urgency=medium

  * Imported Upstream version 1.1.5

 -- Tomasz Buchert <tomasz@debian.org>  Thu, 11 Feb 2016 13:40:44 +0100

pax-utils (1.1.4-1) unstable; urgency=medium

  * Imported Upstream version 1.1.4

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 03 Nov 2015 07:58:01 +0100

pax-utils (1.1.3-1) unstable; urgency=medium

  * Imported Upstream version 1.1.3

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 27 Sep 2015 15:50:33 +0200

pax-utils (1.1.2-1) unstable; urgency=medium

  * Imported Upstream version 1.1.2

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 16 Sep 2015 10:35:04 +0200

pax-utils (1.1.1-1) unstable; urgency=medium

  * Imported Upstream version 1.1.1

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 06 Sep 2015 20:04:58 +0200

pax-utils (1.1-1) unstable; urgency=medium

  * Imported Upstream version 1.1
  * d/patches: drop obsolete patches
  * d/*: fixes according to new upstream releases

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 29 Aug 2015 13:56:38 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: misc
 Priority: extra
 Maintainer: Tomasz Buchert <tomasz@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: autoconf-archive,
+               debhelper (>= 9),
+               dh-autoreconf,
+               gnulib,
                libcap2-dev [linux-any],
+               pkg-config,
                python,
-               python-pyelftools,
-               dh-autoreconf,
-               autoconf-archive,
-               gnulib
+               python-pyelftools
 Standards-Version: 3.9.6
 Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities
 Vcs-Git: git://anonscm.debian.org/collab-maint/pax-utils.git

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,11 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS  = hardening=+pie,+bindnow
 
+CONFIGURE_FLAGS=
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 	# pspax.c on Linux can use sys/capability.h
 	# to get nice textual representations
-	export USE_CAP=yes
+	CONFIGURE_FLAGS += --with-caps
 endif
 
 override_dh_auto_clean:
@@ -14,6 +15,9 @@
 	# which deletes too many files
 	make clean || true
 
+override_dh_auto_configure:
+	dh_auto_configure -- $(CONFIGURE_FLAGS)
+
 override_dh_autoreconf:
 	dh_autoreconf debian/autogen.sh

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://dev.gentoo.org/~vapier/dist/ pax-utils-(.*\..*).tar.xz

## pax-utils 1.1.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-PV := v1.1.5
+PV := v1.1.6
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
 ####################################################################

=== debian/changelog ===
pax-utils (1.1.6-1) unstable; urgency=medium

  * Imported Upstream version 1.1.6
  * Bump Standards-Version to 3.9.7 (no changes required)

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 25 Mar 2016 10:53:01 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                pkg-config,
                python,
                python-pyelftools
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities
 Vcs-Git: git://anonscm.debian.org/collab-maint/pax-utils.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pax-utils.git

## pax-utils 1.1.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-PV := v1.1.6
+PV := v1.1.7
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
 ####################################################################
@@ -67,7 +67,7 @@
 
 ####################################################################
 ELF_TARGETS  = scanelf dumpelf $(shell echo | $(CC) -dM -E - | grep -q __svr4__ || echo pspax)
-ELF_OBJS     = paxelf.o
+ELF_OBJS     = paxelf.o paxldso.o
 MACH_TARGETS = scanmacho
 MACH_OBJS    = paxmacho.o
 COMMON_OBJS  = paxinc.o security.o xfuncs.o

=== debian/changelog ===
pax-utils (1.1.7-1) unstable; urgency=medium

  * New upstream version 1.1.7
  * Bump Standards-Version to 3.9.8 (no changes required)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 27 Nov 2016 16:27:41 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                pkg-config,
                python,
                python-pyelftools
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities
 Vcs-Git: git://anonscm.debian.org/collab-maint/pax-utils.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pax-utils.git

## pax-utils 1.2.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-PV := v1.1.7
+PV := v1.2.2
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
 ####################################################################

=== tests/lddtree/Makefile ===
all: check

%.check:
	./dotest.$(@:.check=)

test check: sh.check
ifneq ($(USE_PYTHON),no)
test check: py.check cmp.check
endif

clean:

.PHONY: all check clean test

=== debian/changelog ===
pax-utils (1.2.2-1) unstable; urgency=medium

  * New upstream version 1.2.2

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 28 Jan 2017 08:43:31 +0100

pax-utils (1.2-1) unstable; urgency=medium

  * d/control: use debhelper 10
  * d/watch: use watch version 4
  * New upstream version 1.2

 -- Tomasz Buchert <tomasz@debian.org>  Mon, 23 Jan 2017 22:27:48 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: extra
 Maintainer: Tomasz Buchert <tomasz@debian.org>
 Build-Depends: autoconf-archive,
-               debhelper (>= 9),
-               dh-autoreconf,
+               debhelper (>= 10),
                gnulib,
                libcap2-dev [linux-any],
                pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -22,4 +22,4 @@
 	dh_autoreconf debian/autogen.sh
 
 %:
-	dh $@ --with autoreconf
+	dh $@

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=4

http://dev.gentoo.org/~vapier/dist/ pax-utils-(.*\..*).tar.xz

## pax-utils 1.2.4

=== debian/changelog ===
pax-utils (1.2.4-1) unstable; urgency=medium

  * New upstream version 1.2.4

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 19 Jan 2019 15:53:28 +0100

pax-utils (1.2.3-3) unstable; urgency=medium

  * refresh packaging (debhelper 12, std-ver 4.3.0)

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 12 Jan 2019 14:58:52 +0100

pax-utils (1.2.3-2) unstable; urgency=medium

  * d/patches: serialize manpage generation (Closes: #908455)

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 11 Sep 2018 21:43:55 +0200

pax-utils (1.2.3-1) unstable; urgency=medium

  * d/control: update vcs links to salsa
  * Fix insecure-copyright-format-uri
  * Switch to dh compat 11
  * Update description (Closes: #900557)
  * Depend on binutils (Closes: #854466)
  * d/watch: update
  * New upstream version 1.2.3 (Closes: #856196)
  * Fix building of man pages (patch)

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 09 Sep 2018 13:55:48 +0200

pax-utils (1.2.2-2) unstable; urgency=medium

  * d/control: add binutils dependency (Closes: #854466)

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 07 Feb 2017 20:31:19 +0100

=== debian/control ===
Source: pax-utils
Maintainer: Tomasz Buchert <tomasz@debian.org>
Section: misc
Priority: optional
Build-Depends: autoconf-archive,
               binutils,
               debhelper (>= 12),
               debhelper-compat (= 12),
               gnulib,
               libcap2-dev [linux-any],
               pkg-config,
               python,
               python-pyelftools,
               xmlto
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/debian/pax-utils
Vcs-Git: https://salsa.debian.org/debian/pax-utils.git
Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities

Package: pax-utils
Architecture: any
Depends: binutils, ${misc:Depends}, ${shlibs:Depends}
Suggests: paxctl
Description: Security-focused ELF files checking tool
 This is a small set of various PaX aware and related utilities for ELF
 binaries. It can check ELF binary files and running processes for
 issues that might be relevant when using ELF binaries along with PaX,
 such as non-PIC code or executable stack and heap.
 .
 This package installs: dumpelf, lddtree, pspax, scanelf, scanmacho
 and symtree.

## pax-utils 1.2.5

=== man/Makefile ===
--- 
+++ 
@@ -4,7 +4,8 @@
 man pdf txt xhtml xhtml-nochunks:
 	@xmlto $@ $(XMLTO_FLAGS_$@) pax-utils.docbook || echo "If this failed, you probably need to emerge ~app-text/docbook-xml-dtd-4.4 app-text/xmlto dev-tex/xmltex"
 	@# scanelf.1 has funky indented lists ... hack it back
-	@sed -i 's:^[.]TP 4:.TP 2:' scanelf.1
+	@sed -i.tmp 's:^[.]TP 4:.TP 2:' scanelf.1
+	@rm scanelf.1.tmp
 clean distclean:
 	rm -f *.1 *.html

=== debian/changelog ===
pax-utils (1.2.5-1ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 31 Mar 2020 17:58:20 +0200

pax-utils (1.2.5-1) unstable; urgency=medium

  * New upstream version 1.2.5
  * Update std-ver to 4.5.0

 -- Tomasz Buchert <tomasz@debian.org>  Sun, 01 Mar 2020 13:50:51 +0100

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,16 @@
                debhelper (>= 12),
                debhelper-compat (= 12),
                gnulib,
-               libcap2-dev [linux-any],
+               libcap-dev [linux-any],
                pkg-config,
-               python,
+               python2,
                python-pyelftools,
                xmlto
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/pax-utils
 Vcs-Git: https://salsa.debian.org/debian/pax-utils.git
 Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities
+Rules-Requires-Root: no
 
 Package: pax-utils
 Architecture: any

## pax-utils 1.2.6

=== debian/changelog ===
pax-utils (1.2.6-2) unstable; urgency=medium

  * Use python3 (Closes: #937251)

 -- Tomasz Buchert <tomasz@debian.org>  Fri, 01 May 2020 11:50:34 +0200

pax-utils (1.2.6-1) unstable; urgency=medium

  * New upstream version 1.2.6
  * Fix debian-rules-uses-as-needed-linker-flag

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 25 Apr 2020 13:50:04 +0200

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
                gnulib,
                libcap-dev [linux-any],
                pkg-config,
-               python2,
-               python-pyelftools,
+               python3,
+               python3-pyelftools,
                xmlto
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/pax-utils

## pax-utils 1.2.9

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,16 @@
-PV := v1.2.2
 # Copyright 2003-2006 Ned Ludd <solar@linbsd.net>
 # Distributed under the terms of the GNU General Public License v2
 ####################################################################
 
-check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; \
+check_compiler = \
+	$(shell if $(CC) $(WUNKNOWN) $(1) -S -o /dev/null -xc /dev/null >/dev/null 2>&1; \
 	then echo "$(1)"; else echo "$(2)"; fi)
-check_gcc_many = $(foreach flag,$(1),$(call check_gcc,$(flag)))
+check_compiler_many = $(foreach flag,$(1),$(call check_compiler,$(flag)))
 
 ####################################################################
 # Avoid CC overhead when installing
 ifneq ($(MAKECMDGOALS),install)
+WUNKNOWN  := $(call check_compiler,-Werror=unknown-warning-option)
 _WFLAGS   := \
 	-Wdeclaration-after-statement \
 	-Wextra \
@@ -20,7 +21,7 @@
              -Wmissing-declarations -Wmissing-prototypes -Wwrite-strings \
              -Wbad-function-cast -Wnested-externs -Wcomment -Winline \
              -Wchar-subscripts -Wcast-align -Wno-format-nonliteral \
-             $(call check_gcc_many,$(_WFLAGS))
+             $(call check_compiler_many,$(_WFLAGS))
 endif
 
 CFLAGS    ?= -O2 -pipe
@@ -87,7 +88,7 @@
 	-fsanitize=leak \
 	-fsanitize=undefined
 debug: clean
-	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb $(call check_gcc_many,$(DEBUG_FLAGS))" all
+	$(MAKE) CFLAGS="$(CFLAGS) -g3 -ggdb $(call check_compiler_many,$(DEBUG_FLAGS))" all
 	@-chpax  -permsx $(ELF_TARGETS)
 	@-paxctl -permsx $(ELF_TARGETS)

=== tests/Makefile ===
SUBDIRS = $(patsubst %/Makefile,%,$(wildcard */Makefile))
abs_top_srcdir = $(realpath $(PWD)/..)
abs_top_builddir = $(realpath $(PWD)/..)
# DO NOT STARE AT THE SUN
all:
%:; $(MAKE) `printf '%s_$@_ ' $(SUBDIRS)`
_words = $(subst _, ,$1)
_dir = $(firstword $(call _words,$@))
_targ = $(lastword $(call _words,$@))
%_:; $(MAKE) -C $(_dir) $(_targ) srcdir=$(abs_top_srcdir)/tests/$(_dir) builddir=$(abs_top_builddir)/tests/$(_dir)

=== tests/lddtree/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 all: check
 
 %.check:
-	./dotest.$(@:.check=)
+	./dotest-$(@:.check=)
 
 test check: sh.check
 ifneq ($(USE_PYTHON),no)

=== debian/changelog ===
pax-utils (1.2.9-1) unstable; urgency=medium

  * New upstream version 1.2.9

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 13 Feb 2021 15:45:19 +0100

pax-utils (1.2.8-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix cross Build-Depends: (Closes: #978060)
    + Drop dependency on binutils, which is build-essential.
    + Annotate python3 with :any.

 -- Helmut Grohne <helmut@subdivi.de>  Sat, 30 Jan 2021 21:16:17 +0100

pax-utils (1.2.8-1) unstable; urgency=medium

  * New upstream version 1.2.8
  * Use debhelper 13

 -- Tomasz Buchert <tomasz@debian.org>  Tue, 29 Dec 2020 19:55:31 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,15 @@
 Section: misc
 Priority: optional
 Build-Depends: autoconf-archive,
-               binutils,
-               debhelper (>= 12),
-               debhelper-compat (= 12),
+               debhelper (>= 13),
+               debhelper-compat (= 13),
                gnulib,
                libcap-dev [linux-any],
                pkg-config,
-               python3,
                python3-pyelftools,
+               python3:any,
                xmlto
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/debian/pax-utils
 Vcs-Git: https://salsa.debian.org/debian/pax-utils.git
 Homepage: https://wiki.gentoo.org/wiki/Hardened/PaX_Utilities

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,5 @@
 #!/usr/bin/make -f
 
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS  = hardening=+pie,+bindnow
 
 CONFIGURE_FLAGS=
